﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GasolineTanker
{
    internal class DrawingObjectGasolineTanker : IDrawingObject
    {
        private DrawingGasolineTanker _gasolineTanker = null;

        public DrawingObjectGasolineTanker(DrawingGasolineTanker gasolineTanker)
        {
            _gasolineTanker = gasolineTanker;
        }

        public DrawingGasolineTanker GetGasolineTanker => _gasolineTanker;

        public float Step => _gasolineTanker?.GasolineTanker?.Step ?? 0;

        public (float Left, float Right, float Top, float Bottom) GetCurrentPosition()
        {
            return _gasolineTanker?.GetCurrentPosition() ?? default;
        }

        public void MoveObject(Direction direction)
        {
            _gasolineTanker?.MoveTransport(direction);
        }

        public void SetObject(int x, int y, int width, int height)
        {
            _gasolineTanker.SetPosition(x, y, width, height);
        }

        void IDrawingObject.DrawningObject(Graphics g)
        {
            _gasolineTanker.DrawTransport(g);
        }
        public string GetInfo() => _gasolineTanker?.GetDataForSave();
        public static IDrawingObject Create(string data) => new DrawingObjectGasolineTanker(data.CreateDrawingGasolineTanker());

        public bool Equals(IDrawingObject? other)
        {
            if (other is not DrawingObjectGasolineTanker otherGasolineTanker)
            {
                return false;
            }
            var entity = _gasolineTanker.GasolineTanker;
            var otherEntity = otherGasolineTanker._gasolineTanker.GasolineTanker;
            if (entity.GetType() != otherEntity.GetType() ||
                entity.Speed != otherEntity.Speed ||
                entity.Weight != otherEntity.Weight ||
                entity.BodyColor != otherEntity.BodyColor)
            {
                return false;
            }
            if (entity is EntityImprovedGasolineTanker entityImprovedGasolineTanker &&
                otherEntity is EntityImprovedGasolineTanker otherEntityWarmlyGasolineTanker && (
                entityImprovedGasolineTanker.BodyColor != otherEntityWarmlyGasolineTanker.BodyColor ||
                entityImprovedGasolineTanker.DopColor != otherEntityWarmlyGasolineTanker.DopColor ||
                entityImprovedGasolineTanker.BodyKit != otherEntityWarmlyGasolineTanker.BodyKit))
            {
                return false;
            }
            return true;
        }
    }
}
