﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GasolineTanker
{
    internal class GasolineTankerCompareByColor : IComparer<IDrawingObject>
    {
        public int Compare(IDrawingObject? x, IDrawingObject? y)
        {
            var xGasolineTanker = x as DrawingObjectGasolineTanker;
            var yGasolineTanker = y as DrawingObjectGasolineTanker;
            if (xGasolineTanker == yGasolineTanker)
            {
                return 0;
            }
            if (xGasolineTanker == null)
            {
                return 1;
            }
            if (yGasolineTanker == null)
            {
                return -1;
            }
            var xEntity = xGasolineTanker.GetGasolineTanker.GasolineTanker;
            var yEntity = yGasolineTanker.GetGasolineTanker.GasolineTanker;
            var colorWeight = xEntity.BodyColor.ToArgb().CompareTo(yEntity.BodyColor.ToArgb());
            if (colorWeight != 0 ||
                xEntity is not EntityImprovedGasolineTanker xEntityImprovedGasolineTanker ||
                yEntity is not EntityImprovedGasolineTanker yEntityImprovedGasolineTanker)
            {
                return colorWeight;
            }
            return xEntityImprovedGasolineTanker.DopColor.ToArgb().CompareTo(yEntityImprovedGasolineTanker.DopColor.ToArgb());
        }
    }
}
