﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GasolineTanker
{
    internal class GasolineTankerCompareByType : IComparer<IDrawingObject>
    {
        public int Compare(IDrawingObject? x, IDrawingObject? y)
        {
            var xGasolineTanker = x as DrawingObjectGasolineTanker;
            var yGasolineTanker = y as DrawingObjectGasolineTanker;
            if (xGasolineTanker == yGasolineTanker)
            {
                return 0;
            }
            if (xGasolineTanker == null)
            {
                return 1;
            }
            if (yGasolineTanker == null)
            {
                return -1;
            }
            if (xGasolineTanker.GetGasolineTanker.GetType().Name != yGasolineTanker.GetGasolineTanker.GetType().Name)
            {
                if (xGasolineTanker.GetGasolineTanker.GetType() == typeof(DrawingGasolineTanker))
                {
                    return -1;
                }
                return 1;
            }
            var speedCompare = xGasolineTanker.GetGasolineTanker.GasolineTanker.Speed.CompareTo(yGasolineTanker.GetGasolineTanker.GasolineTanker.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xGasolineTanker.GetGasolineTanker.GasolineTanker.Weight.CompareTo(yGasolineTanker.GetGasolineTanker.GasolineTanker.Weight);
        }
    }
}

